package xyz.lychee.lagfixer.libs.adventure.platform.bukkit;

import java.util.function.Predicate;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import xyz.lychee.lagfixer.libs.adventure.audience.Audience;
import xyz.lychee.lagfixer.libs.adventure.platform.AudienceProvider;
import xyz.lychee.lagfixer.libs.adventure.sound.Sound;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public interface BukkitAudiences extends AudienceProvider {
   static @NotNull BukkitAudiences create(final @NotNull Plugin plugin) {
      return BukkitAudiencesImpl.instanceFor(plugin);
   }

   @NotNull
   static @NotNull Builder builder(final @NotNull Plugin plugin) {
      return BukkitAudiencesImpl.builder(plugin);
   }

   static Sound.@NotNull Emitter asEmitter(final @NotNull Entity entity) {
      return new BukkitEmitter(entity);
   }

   @NotNull Audience sender(final @NotNull CommandSender sender);

   @NotNull Audience player(final @NotNull Player player);

   @NotNull Audience filter(final @NotNull Predicate<CommandSender> filter);

   public interface Builder extends AudienceProvider.Builder<BukkitAudiences, Builder> {
   }
}
